/* $Id$

This file is part of libmspgl
Copyright © 2007  Mikko Rasa, Mikkosoft Productions
Distributed under the LGPL
*/

#include "matrix.h"

namespace Msp {
namespace GL {

void matrix_mode(MatrixMode m)
{
	glMatrixMode(m);
}

void load_identity()
{
	glLoadIdentity();
}

void mult_matrix(const float *matrix)
{
	glMultMatrixf(matrix);
}

void mult_matrix(const double *matrix)
{
	glMultMatrixd(matrix);
}

void push_matrix()
{
	glPushMatrix();
}

void pop_matrix()
{
	glPopMatrix();
}

} // namespace GL
} // namespace Msp
