/* $Id$

This file is part of libmspgl
Copyright © 2007 Mikko Rasa, Mikkosoft Productions
Distributed under the LGPL
*/

#ifndef MSP_GL_MESH_H_
#define MSP_GL_MESH_H_

#include <msp/datafile/loader.h>
#include "batch.h"
#include "vertexarray.h"

namespace Msp {
namespace GL {

class Mesh
{
public:
	class Loader: public DataFile::Loader
	{
	public:
		Loader(Mesh &);
	private:
		Mesh &mesh;

		void vertices(VertexFormat);
		void batch(PrimitiveType);
	};

	Mesh();
	Mesh(VertexFormat f);
	RefPtr<VertexArrayBuilder> modify_vertices() { return vertices.modify(); }
	void add_batch(const Batch &b);
	const VertexArray &get_vertices() const { return vertices; }
	const std::list<Batch> &get_batches() { return batches; }
	void draw() const;
private:
	VertexArray vertices;
	std::list<Batch> batches;
};

} // namespace GL
} // namespace Msp

#endif
