/* $Id$

This file is part of libmspgl
Copyright © 2007  Mikko Rasa, Mikkosoft Productions
Distributed under the LGPL
*/

#include "vertexformat.h"

namespace Msp {
namespace GL {

uint get_stride(VertexFormat f)
{
	uint stride=0;
	for(uint fmt=f; fmt; fmt>>=4)
		stride+=(fmt&3)+1;
	return stride*sizeof(float);
}

std::istream &operator>>(std::istream &in, VertexFormat &f)
{
	std::string str;
	in>>str;

	unsigned start=0;
	f=NODATA;

	while(1)
	{
		unsigned underscore=str.find('_', start);
		if(!str.compare(start, underscore-start, "VERTEX2"))
			f=(f,VERTEX2);
		else if(!str.compare(start, underscore-start, "VERTEX3"))
			f=(f,VERTEX3);
		else if(!str.compare(start, underscore-start, "VERTEX4"))
			f=(f,VERTEX4);
		else if(!str.compare(start, underscore-start, "NORMAL3"))
			f=(f,NORMAL3);
		else if(!str.compare(start, underscore-start, "TEXCOORD1"))
			f=(f,TEXCOORD1);
		else if(!str.compare(start, underscore-start, "TEXCOORD2"))
			f=(f,TEXCOORD2);
		else if(!str.compare(start, underscore-start, "TEXCOORD3"))
			f=(f,TEXCOORD3);
		else if(!str.compare(start, underscore-start, "TEXCOORD4"))
			f=(f,TEXCOORD4);
		else if(!str.compare(start, underscore-start, "COLOR4UB"))
			f=(f,COLOR4_UBYTE);
		else if(!str.compare(start, underscore-start, "COLOR3F"))
			f=(f,COLOR3_FLOAT);
		else if(!str.compare(start, underscore-start, "COLOR4F"))
			f=(f,COLOR4_FLOAT);
		else
		{
			in.setstate(std::ios_base::failbit);
			break;
		}

		if(underscore==std::string::npos)
			break;
		start=underscore+1;
	}

	return in;
}

} // namespace GL
} // namespace Msp
